﻿package
{
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.display.Stage;
	
	import com.viget.*;
	
	public class Main extends Sprite
	{
		private var i:uint;
		private var indAry:Array = new Array();
		private var floorPlan:MovieClip = new MovieClip();
	
		private var cornerInd:CornerIndicator;
		private var floor:Floor;
		private var boundary:Boundary;
		private var wallData:WallData;
		
		protected var model:Model = Model.instance;
		
		public function Main()
		{
			addChild(floorPlan);
			model.Floor = floorPlan;
			
			//preset positions for corner indicators
			var indHash:Array = new Array({X:0, Y:0}, {X:0, Y:200}, {X:200, Y:200}, {X:200, Y:0});
			
			//add indicators
			for(i = 0; i < indHash.length; i++)
			{
				cornerInd = new CornerIndicator()
				cornerInd.x = indHash[i].X;
				cornerInd.y = indHash[i].Y;
				cornerInd.IndId = i;
				floorPlan.addChild(cornerInd);
				
				indAry.push(cornerInd);
			}
			
			//send ind array to model
			model.IndArray = indAry;
			
			//add and place all assets
			initAssets();
			addAssets();
			placeAssets();
		}
		
		private function initAssets():void
		{
			floor = new Floor();
			
			boundary = new Boundary();
			wallData = new WallData();
		}
		
		private function addAssets():void
		{
			floorPlan.addChildAt(floor, 0);
			floorPlan.addChildAt(boundary, 1);
			floorPlan.addChildAt(wallData, 1);
		}
		
		private function placeAssets():void
		{
			floorPlan.x = stage.stageWidth/2 - floorPlan.width/2;
			floorPlan.y = stage.stageHeight/2 - floorPlan.height/2;
		}
	}
}