﻿package com.viget
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	public class CornerIndicator extends Sprite
	{
		private var _indId:uint;
		
		protected var model:Model = Model.instance;
		protected var control:Controller = Controller.instance;
		
		public function CornerIndicator()
		{
			graphics.beginFill(0x000000);
			graphics.drawCircle(0, 0, 7)
			
			buttonMode = true;
			doubleClickEnabled = true;
			addEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
			addEventListener(MouseEvent.MOUSE_UP, mouseUp);
			addEventListener(MouseEvent.DOUBLE_CLICK, mouseDblClick);
			
			model.addEventListener(Event.CHANGE, this.update)
		}
		
		//=========================
		//EVENT LISTENERS
		//=========================
		private function mouseDown(e:Event):void
		{
			this.startDrag();
			model.RedrawFloor = true;
		
			//use enter frame event because mouse move is too slow and choppy
			addEventListener(Event.ENTER_FRAME, mouseMoving);
		}
		
		private function mouseUp(e:Event):void
		{
			this.stopDrag();
			model.RedrawFloor = false;
			
			removeEventListener(Event.ENTER_FRAME, mouseMoving);
		}
		
		private function mouseMoving(e:Event):void
		{
			model.RedrawFloor = true;
		}
		
		private function mouseDblClick(e:Event):void
		{
			control.removeInd(this);
			model.RedrawFloor = true;
		}
		
		//=========================
		//EVENT LISTENERS
		//=========================
		public function get IndId():uint
		{
			return _indId;
		}
		
		public function set IndId(val:uint):void
		{
			_indId = val;
		}
		
		public function update(e:Event):void
		{
			
		}
	}
}