﻿package com.viget
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.text.Font;
	import flash.text.AntiAliasType;
		
	public class WallData extends Sprite
	{
		public var borderFont:BorderFont;
		private var radians:Number
		private var degrees:Number;
		private var wlAry:Array = new Array();
		private var tAry:Array = new Array();
		private var t:TextField;
		private var tmc:MovieClip;
		private var i:uint
		private var feet:Number;
		private var inches:String
		private var inchAry:Array;
		
		protected var model:Model = Model.instance;
		
		public function WallData()
		{
			removeWallData();
			draw();
			
			model.addEventListener(Event.CHANGE, this.update)
		}
		
		private function draw():void
		{
			tAry = new Array();
			
			for(var b:uint = 0; b < model.IndArray.length; b++)
			{
				if(b+1 == model.IndArray.length)
					boundLength(model.IndArray[model.IndArray.length-1], model.IndArray[0]);
				else
					boundLength(model.IndArray[b], model.IndArray[b+1]);
			}
		}
		
		private function boundLength(p1:CornerIndicator, p2:CornerIndicator):void
		{
			var point1:Point = new Point(p1.x, p1.y);
			var point2:Point = new Point(p2.x, p2.y);
			
			tField();
			
			radians = Math.atan((p2.y - p1.y) / (p2.x - p1.x));
			degrees = radians * (180 / Math.PI);
			
			borderFont.rotation = degrees;
			feet = Math.floor(Point.distance(point1, point2)/model.Scale)
			inches = new String(12 * ((Point.distance(point1, point2)/model.Scale) - feet))
			inchAry = inches.split('.');
			borderFont.txt.text = new String(feet + "' " + inchAry[0] + '"' + '   ('+Math.round(degrees) + ' deg)');
			borderFont.txt.width = borderFont.txt.textWidth + 5;
			
			borderFont.x = Point.interpolate(point1, point2, 0.5).x; 
			borderFont.y = Point.interpolate(point1, point2, 0.5).y;
			
			borderFont.txt.x = -(borderFont.txt.textWidth/2);
			borderFont.txt.y = -(borderFont.txt.textHeight/2);
		}

		private function tField():void
		{
			borderFont = new BorderFont();
			addChild(borderFont)

			tAry.push(borderFont);
		}
		
		public function removeWallData():void
		{
			for(i = 0; i < tAry.length; i++)
			{
				removeChild(tAry[i]);
			}
		}
		
		//=========================
		//EVENT LISTENERS
		//=========================
		public function update(e:Event):void
		{
			if(model.RedrawFloor)
			{
				removeWallData();
				draw();
			}
		}
	}
}